/*
 *                      ..::PictoGame::..
 *
 * Copyright (C) DKT 2010 <dktcoding [at] gmail>
 *
 * PictoGame is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or any later
 * version.
 *
 * PictoGame is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package picto.app.interfaces;

import picto.utils.Picto;

/**
 *
 * @author Fido <dktcoding [at] gmail>
 */
public interface Playable {

    /**
     * Gets the current number of columns
     * @return current number of columns on the screen
     */
    int getXSize();
    /**
     * Gets the current number of rows
     * @return current number of rows on the screen
     */
    int getYSize();
    /**
     * Cleans the board
     */
    void clean();
    /**
     * Shows the solution on the screen (It's not necessary to calculate it,
     * just show it)
     */
    void solve();
    void updateColors();
    void checkBoard(boolean reset_wrong);
    void updateHeaderFocus(int i, int j);

    /**
     * @return the Picto of the current game
     */
    Picto getPic();
}
